; Ashes rel 0.01
; Created by Graechan
;
;     
; Comments directed to http://gimpchat.com or http://gimpscripts.com
;
; License: GPLv3
;    This program is free software: you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation, either version 3 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
;    GNU General Public License for more details.
;
;    To view a copy of the GNU General Public License
;    visit: http://www.gnu.org/licenses/gpl.html
;
;
; ------------
;| Change Log |
; ------------ 
; Rel 0.01 - Initial Release 
(define (apply-fire-effect image drawable
                                      size
                                      glow-color
									  bkg-color
									  intensity
									  burn-size
									  opacity
									  conserve
									  )
  (let* (
         (image-layer (car (gimp-image-get-active-layer image)))
		 (width (car (gimp-image-width image)))
		 (height (car (gimp-image-height image)))
		 (tubes-layer 0)
		 (glow-layer 0)
		 (bkg-layer 0)
		 (tubes-copy 0)
		 (pattern-layer 0)
		 (visible-layer 0)
		 (ashes-layer 0)
         
         )
    (gimp-context-push)
	(gimp-context-set-foreground '(0 0 0))
	(gimp-context-set-background '(255 255 255))
	
;;;;create the burn amount effect
	(gimp-selection-layer-alpha image-layer)
	(script-fu-distress-selection image 
	                              image-layer 
								  127       ;Threshold (bigger 1<-->255 smaller)
								  burn-size         ;Spread (8 0 1000 1 10 0 1)
								  4         ;Granularity (1 is low) (4 1 25 1 10 0 1)
								  2         ;Smooth (2 1 150 1 10 0 1)
								  TRUE      ;Smooth horizontally TRUE
								  TRUE)     ;Smooth vertically TRUE
	(gimp-context-set-foreground '(0 0 0))
	(gimp-edit-fill image-layer FOREGROUND-FILL)
	(gimp-selection-invert image)
	(gimp-edit-clear image-layer)
	(gimp-selection-none image) 
	
    (gimp-image-undo-disable image)
    (apply-neon-logo-effect image image-layer 3160 bkg-color glow-color FALSE)   ;size bg-color glow-color shadow
    (gimp-image-undo-enable image)
    ;(gimp-display-new image)
	

;;;;identify the new layers	
    (set! tubes-layer (car (gimp-layer-new image width height RGBA-IMAGE "new tubes" 100 NORMAL-MODE)))
    (gimp-image-add-layer image tubes-layer -1)
	(gimp-image-raise-layer-to-top image tubes-layer)
    (set! tubes-layer (car (gimp-image-merge-down image tubes-layer EXPAND-AS-NECESSARY)))
	
	(set! tubes-copy (car (gimp-layer-copy tubes-layer TRUE)))
	(gimp-image-add-layer image tubes-copy -1)
	(gimp-drawable-set-name tubes-copy "tubes-copy")
	(gimp-drawable-set-visible tubes-copy FALSE)
	(gimp-layer-set-mode tubes-copy OVERLAY-MODE)
	
	(set! glow-layer (car (gimp-layer-new image width height RGBA-IMAGE "new glow" 100 NORMAL-MODE)))
    (gimp-image-add-layer image glow-layer 2)
	(set! glow-layer (car (gimp-image-merge-down image glow-layer EXPAND-AS-NECESSARY)))
	
	(set! bkg-layer (car (gimp-layer-new image width height RGBA-IMAGE "new bkg" 100 NORMAL-MODE)))
    (gimp-image-add-layer image bkg-layer 3)
	(set! bkg-layer (car (gimp-image-merge-down image bkg-layer EXPAND-AS-NECESSARY)))
	
	(set! glow-layer (car (gimp-image-merge-down image tubes-layer EXPAND-AS-NECESSARY)))
	
	(set! pattern-layer (car (gimp-layer-new image width height RGBA-IMAGE "pattern" 100 OVERLAY-MODE)))
    (gimp-image-add-layer image pattern-layer -1)
	(gimp-context-set-pattern "Burlwood")
	(gimp-drawable-fill pattern-layer PATTERN-FILL)
	(gimp-desaturate-full pattern-layer 1)
	(gimp-levels pattern-layer 0 0 160 0.60 0 255)
	(gimp-context-set-gradient "Incandescent")
	(plug-in-gradmap 1 image pattern-layer)
	(gimp-drawable-set-visible bkg-layer FALSE)
	
	(plug-in-displace 1 image glow-layer intensity intensity TRUE TRUE pattern-layer pattern-layer 0)
	
	(plug-in-gradmap 1 image glow-layer)
	(gimp-layer-resize-to-image-size tubes-copy)
	(gimp-selection-layer-alpha tubes-copy)
	(gimp-selection-invert image)
	(gimp-edit-clear pattern-layer)
	(gimp-selection-none image)
	
	(set! visible-layer (car (gimp-layer-new-from-visible image image "visible")))
	(gimp-image-add-layer image visible-layer -1)
	(gimp-drawable-set-visible bkg-layer TRUE)
	(gimp-drawable-set-visible tubes-copy TRUE)
	(plug-in-mblur 1 image visible-layer 0 60 90 (/ width 2) (/ height 2))
	(gimp-layer-set-mode visible-layer HARDLIGHT-MODE) ;GRAIN-MERGE
	(gimp-layer-set-mode tubes-copy HARDLIGHT-MODE)
	(gimp-layer-set-offsets tubes-copy intensity intensity)
	(gimp-layer-resize-to-image-size tubes-copy)
	(gimp-layer-set-opacity tubes-copy opacity)
	(if (= conserve FALSE)
	(begin	
	(set! tubes-copy (car (gimp-image-merge-down image tubes-copy EXPAND-AS-NECESSARY)))
	(set! tubes-copy (car (gimp-image-merge-down image tubes-copy EXPAND-AS-NECESSARY)))
	(set! tubes-copy (car (gimp-image-merge-down image tubes-copy EXPAND-AS-NECESSARY)))
	(set! ashes-layer (car (gimp-image-merge-down image tubes-copy EXPAND-AS-NECESSARY)))
	(gimp-drawable-set-name ashes-layer "Ashes")))
	
	(gimp-context-pop)
	
    )
  )
(define (script-fu-ashes-logo 
                                      text 
                                      font-in 
                                      font-size
                                      glow-color 
									  bkg-color
									  intensity-in
									  burn-size-in
									  frames
									  opacity
									  conserve-in
									  )
  (let* (
         (image (car (gimp-image-new 256 256 RGB)))
         (border (/ font-size 4))
		 (font (if (> (string-length font-in) 0) font-in (car (gimp-context-get-font))))
         (size-layer (car (gimp-text-fontname image -1 0 0 text border TRUE font-size PIXELS font)))
         (final-width (car (gimp-drawable-width size-layer)))
         (final-height (car (gimp-drawable-height size-layer)))
         (text-layer 0)
         (width 0)
         (height 0)
		 (pattern-layer 0)
         (intensity (+ intensity-in 1))
		 (conserve conserve-in)
		 (text1-layer 0)
		 (burn-size burn-size-in)
		 (cnt frames)
		 (inc (/ 50 frames))
         )
    (gimp-context-push)
	(gimp-context-set-foreground '(0 0 0))
	(gimp-context-set-background '(255 255 255))

;;;;Add the text layer for a temporary larger Image size
    (gimp-image-remove-layer image size-layer)
	(set! text-layer (car (gimp-text-fontname image -1 0 0 text 158 TRUE 632 PIXELS font)))
    (set! width (car (gimp-drawable-width text-layer)))
    (set! height (car (gimp-drawable-height text-layer)))
    (gimp-image-resize-to-layers image)
	
;;;;centre text on line
	(gimp-text-layer-set-justification text-layer 2)	    

;;;;create the animation frames	
    (if (> frames 1) (set! conserve FALSE))
	(if (> frames 1) (set! burn-size 0))
	(while (> cnt 0)
	(gimp-image-undo-disable image)
	(set! text1-layer (car (gimp-layer-copy text-layer TRUE)))
	(gimp-image-add-layer image text1-layer -1)
	(gimp-drawable-set-name text1-layer "text1-layer")
	(apply-fire-effect image text1-layer font-size glow-color bkg-color intensity burn-size opacity conserve)
	(gimp-drawable-set-name (car(gimp-image-get-active-layer image)) text)
	(gimp-image-undo-enable image)
	(set! cnt (- cnt 1))
	(set! burn-size (+ burn-size inc))
	(gimp-displays-flush)
	)
	(if (or (> frames 1) (= conserve FALSE)) (gimp-image-remove-layer image text-layer))
	
	
;;;;scale the image to its intended size
	(gimp-image-scale-full image final-width final-height 2)	
	
	(gimp-context-pop)    
    (gimp-display-new image)
	(gimp-displays-flush)
    )
  ) 
(script-fu-register "script-fu-ashes-logo"
  "Ogień..."
  "Create an image with a text layer over a pattern layer"
  "Graechan"
  "Graechan"
  "June 2011"
  ""
  SF-TEXT       "Text"    "ASHES"
  SF-FONT       "Font"               "Arial Bold"
  SF-ADJUSTMENT "Font size (pixels)" '(350 6 1000 1 1 0 1)
  SF-COLOR      "Glow color"         '(244 122 3)
  SF-COLOR      "Background color"         '(0 0 0)
  SF-ADJUSTMENT "Intensywność ognia" '(10 0 100 .01 10 2 0)
  SF-ADJUSTMENT _"Burn size" '(20 0 50 1 5 0 0)
  SF-ADJUSTMENT _"Frames" '(1 1 50 1 5 0 0)
  SF-ADJUSTMENT "Opacity" '(100 0 100 .01 10 2 0)
  SF-TOGGLE     "Zachować warstwy"   FALSE
  )
(script-fu-menu-register "script-fu-ashes-logo"
  "<Image>/File/Create/Logos"
  )