(define (script-fu-MaskingShadow  text
			          size
			          font
			          text-color
			          shadow-color
				  bind?
				  bind-color
	)

  (let* (
	  (img (car (gimp-image-new 256 256 RGB)))
          (border (/ size 4))
	  (text-layer 0)
	  (shadow-layer 0)
	  (bind-layer 0)
	  (back-layer 0)
	  (width 0)
	  (height 0)
	  (oldfg 0)
	  (oldbg 0)
        )


	(set! oldfg (car (gimp-palette-get-foreground)))
	(set! oldbg (car (gimp-palette-get-background)))
	(gimp-palette-set-foreground text-color)
	(gimp-palette-set-background shadow-color)

	(set! text-layer (car (gimp-text-fontname img -1 0 0 text border TRUE size 0 font)))
	(set! shadow-layer (car (gimp-layer-copy text-layer 1)))
	(set! bind-layer (car (gimp-layer-copy text-layer 1)))

	(set! width (car (gimp-drawable-width text-layer)))
	(set! height (car (gimp-drawable-height text-layer)))

	(set! back-layer (car (gimp-layer-new img width height RGBA-IMAGE "Background" 100 NORMAL)))

	(gimp-image-resize img width height 0 0)

	(gimp-layer-set-name text-layer "Text")
	(gimp-layer-set-name shadow-layer "Shadow")
	(gimp-layer-set-name bind-layer "Bind")
	(gimp-image-add-layer img bind-layer -1)
	(gimp-image-add-layer img shadow-layer 2)
	(gimp-image-add-layer img back-layer 3)

	(gimp-layer-set-offsets text-layer -2 -2)
	(gimp-layer-set-offsets shadow-layer 2 2)
	(gimp-layer-set-offsets bind-layer 2 0)

	(gimp-selection-all img)
	(gimp-drawable-fill back-layer 2)
	(gimp-selection-none img)

	(gimp-selection-layer-alpha shadow-layer)
	(gimp-edit-fill shadow-layer 1)
	(gimp-selection-translate img -2 -2)
	(gimp-edit-fill shadow-layer 3)
	(gimp-selection-none img)

	(gimp-selection-layer-alpha bind-layer)
	(gimp-palette-set-background bind-color)
	(gimp-edit-fill bind-layer 1)
	(gimp-selection-none img)
	(gimp-drawable-transform-shear bind-layer 0 -60 0 1 0 3 0)
	(gimp-layer-set-mode bind-layer SCREEN)

	(gimp-layer-resize-to-image-size text-layer)
	(gimp-layer-resize-to-image-size shadow-layer)
	(gimp-layer-resize-to-image-size bind-layer)
	(gimp-layer-set-name text-layer "Text")
	(gimp-layer-set-name shadow-layer "Shadow")
	(gimp-layer-set-name bind-layer "Text")
	(if (eqv? bind? FALSE)
	    (gimp-image-remove-layer img bind-layer)
	)
	(if (eqv? bind? TRUE)
	    (gimp-image-merge-down img bind-layer 0)
	)
	(gimp-palette-set-foreground oldfg)
	(gimp-palette-set-background oldbg)
	(gimp-display-new img)
  )

)

(script-fu-register "script-fu-MaskingShadow"
		    _"Masking Shadow..."
		    "The text is making logo that have masked shadow."
		    "yotsuba."
		    "Copyright 2005, product by yotsuba."
		    "2005"
		    ""
		    SF-STRING _"Tekst" "Masking Shadow"
		    SF-ADJUSTMENT _"Rozmiar czcionki (px)"     '(80 2 1000 1 10 0 1)
		    SF-FONT   _"Czcionka" "Book Antiqua"
		    SF-COLOR  _"Kolor"  '(255 0 0)
		    SF-COLOR  _"Kolor cienia"  '(0 0 0)
		    SF-TOGGLE  _"Dekoracja tekstu"  TRUE
		    SF-COLOR  _"Kolor dekoracji"  '(255 255 0)
)

(script-fu-menu-register "script-fu-MaskingShadow"
		    "<Image>/File/Create/Logos"
)