; Created by Graechan
;    With thanks to Gino D for his Drawable Multiplication script
;    that made adding the 3D option much easier.
;    Also thanks to Draconian for his great tutorials
;    that inspired me to write this script. 
; Comments directed to http://gimpchat.com or http://gimpscripts.com
;
; License: GPLv3
;    This program is free software: you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation, either version 3 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
;    GNU General Public License for more details.
;
;    To view a copy of the GNU General Public License
;    visit: http://www.gnu.org/licenses/gpl.html
;
;;;;
(define (script-fu-metal-text 
                                      img-width
                                      img-height
                                      text 
                                      font 
                                      size
									  metal
									  tint-color
									  3d-effect
                                      bkg-type 
                                      pattern
                                      bkg-color
									  gradient
									  palette
									  conserve)
  (let* (
         (image (car (gimp-image-new 256 256 RGB)))
         
         (border (/ size 4))
         (size-layer (car (gimp-text-fontname image -1 0 0 text border TRUE size PIXELS font)))
         (final-width (car (gimp-drawable-width size-layer)))
         (final-height (car (gimp-drawable-height size-layer)))
         (text-layer 0)
         (width 0)
         (height 0)
         (bkg-layer 0)
		 (palette1 0)
		 (palette-gradient 0)
		 (img-channel 0)
		 (tint-layer 0)
		 (3d-layer 0)
		 (metal-text-layer 0)
         ;;(graechan-chiseled 0)
         )
    (gimp-context-push)
	

	
;;;;Add the text layer for a temporary larger Image size
    (set! text-layer (car (gimp-text-fontname image -1 0 0 text 158 TRUE 632 PIXELS font)))
    (set! width (car (gimp-drawable-width text-layer)))
    (set! height (car (gimp-drawable-height text-layer)))    
    (gimp-image-remove-layer image size-layer)
    (gimp-image-resize-to-layers image)
	
;;;;centre text on line
	(gimp-text-layer-set-justification text-layer 2)

;;;;set the text clolor to white    
    (gimp-context-set-foreground '(255 255 255))
	(gimp-selection-layer-alpha text-layer)
	(gimp-edit-fill text-layer FOREGROUND-FILL)
	
;;;;save the selection
	(gimp-selection-save image)
	(set! img-channel (car (gimp-image-get-active-drawable image)))	
	(gimp-channel-set-opacity img-channel 100)	
	(gimp-drawable-set-name img-channel "img-channel")
	(gimp-selection-none image)
	
;;;;blur the img-channel
	(plug-in-gauss-rle2 RUN-NONINTERACTIVE image img-channel 10 10)
	(gimp-image-set-active-layer image text-layer)
    
;;;;create the background layer    
	(set! bkg-layer (car (gimp-layer-new image width height RGBA-IMAGE "Background" 100 NORMAL-MODE)))
    (gimp-image-add-layer image bkg-layer 1)
	          
;;;;resize the text-layer		
    (gimp-image-set-active-layer image text-layer)
	(gimp-layer-resize-to-image-size text-layer)    

	;;;;;;;;;;;;Main body of Script;;;;;;;;;;	
	(gimp-selection-load img-channel)
	(gimp-edit-clear text-layer)
	(plug-in-solid-noise RUN-NONINTERACTIVE image text-layer 0 0 0 1 5 5)
	(plug-in-bump-map RUN-NONINTERACTIVE image text-layer img-channel 360 45 38 0 0 0 0 TRUE FALSE 0)
	(gimp-curves-spline text-layer 0 18 #(0 255 30 0 65 255 95 0 125 255 160 0 190 255 222 0 255 255))
	(gimp-selection-invert image)
    (gimp-edit-clear text-layer)
	;(gimp-selection-none image)
    (gimp-selection-invert image)

 (if (= metal 1) (gimp-context-set-foreground '(255 215 0)));gold 	
 (if (= metal 2) (gimp-context-set-foreground '(192 192 192)));silver	
 (if (= metal 3) (gimp-context-set-foreground '(250 180 150)));copper
 (if (= metal 4) (gimp-context-set-foreground '(166 125 61)));bronze
 (if (= metal 5) (gimp-context-set-foreground tint-color));colored tint
 (if (> metal 0)
   (begin 
	(set! tint-layer (car (gimp-layer-new image width height RGBA-IMAGE "Tint" 100 MULTIPLY-MODE)))
    (gimp-image-add-layer image tint-layer -1) 
	(gimp-edit-fill tint-layer FOREGROUND-FILL)
	(gimp-selection-invert image)
    (gimp-edit-clear tint-layer)
    (set! text-layer (car (gimp-image-merge-down image tint-layer CLIP-TO-IMAGE)))	 
   )
 )	
	(gimp-drawable-set-name text-layer "Text Layer")
	(gimp-selection-none image)

;;;;create the 3d-layer	
 (if (= 3d-effect TRUE)
   (begin     
	(script-fu-drawable-multiplication image text-layer 30 1 1 2 TRUE FALSE)
	(set! 3d-layer (car (gimp-image-get-active-drawable image)))
	(gimp-drawable-set-name 3d-layer "3D Layer")
	(gimp-layer-resize-to-image-size 3d-layer)
   )
 )
 
;;;;Finish the Image   
    ;;Scale Image to it's original size and merge the layers
    (gimp-image-scale-full image final-width final-height 2)

;;;;fill the background layer
	(gimp-context-set-pattern pattern)
	(gimp-context-set-background bkg-color)
	(gimp-context-set-gradient gradient)
	(if (= bkg-type 1) (gimp-drawable-fill bkg-layer PATTERN-FILL))		
    (if (= bkg-type 2) (gimp-drawable-fill bkg-layer BACKGROUND-FILL))	
    (if (= bkg-type 3) (gimp-edit-blend bkg-layer CUSTOM-MODE NORMAL-MODE  GRADIENT-LINEAR 100 0 REPEAT-NONE FALSE FALSE 3 0.2 TRUE 0 0 final-width final-height));; GRADIENT-LINEAR ; GRADIENT-CONICAL-SYMMETRIC
    
 (if (= conserve FALSE) 
   (begin 
	(set! metal-text-layer (car (gimp-image-merge-visible-layers image  CLIP-TO-IMAGE)))	
	(gimp-drawable-set-name metal-text-layer "Metal Text")
   )
 )
	
	
	
	(gimp-context-pop)
	
    
    

    (gimp-display-new image)
    )
  ) 
(script-fu-register "script-fu-metal-text"
  "Metal Text"
  "Create a Metalic text layer over a Background layer, the Drawable Multiplication script is required to use the 3D option."
  "Graechan"
  "Graechan"
  "Feb 2012"
  ""
  SF-ADJUSTMENT "Szerokość (w pikselach)" '(250 1 1000 1 10 0 1)
  SF-ADJUSTMENT "Wysokość (w pikselach)" '(250 1 1000 1 10 0 1)
  SF-TEXT       "Tekst"    "Metal\nText"
  SF-FONT       "Czcionka"               "JasmineUPC Bold"
  SF-ADJUSTMENT "Rozmiar czcionki (pix)" '(350 6 500 1 1 0 1)
  SF-OPTION "Typ metalu" '("Chrom" "Złoto" "Srebro" "Miedź" "Brąz" "Kolorowy Odcień")
  SF-COLOR      "Odcień koloru"         '(0 0 255)
  SF-TOGGLE     "Dodać efekt 3D"   FALSE
  SF-OPTION "Typ tła" '("Brak" "Deseń" "Kolor" "Gradient")
  SF-PATTERN    "Deseń"            "Pink Marble"
  SF-COLOR      "Kolor tła"         '(153 153 153)
  SF-GRADIENT   "Gradient tła" "Abstract 3"
  SF-PALETTE    "Palleta tła"  "Default"
  SF-TOGGLE     "Zachować warstwy"   FALSE
  )
(script-fu-menu-register "script-fu-metal-text"
  "<Image>/File/Create/Logos"
  )